<html>
<head>
	<meta charset="utf-8">

	<script src="https://code.jquery.com/jquery-3.6.0.js"></script>
	<script src="static/js/bootstrap.js"></script>
	
	<link rel="stylesheet" href="static/css/bootstrap.css" />
<style>
text {
cursor:pointer;
}
.links line {
  stroke: #999;
  stroke-opacity: 0.6;
}

.nodes circle {
  stroke: #fff;
  stroke-width: 1.5px;
}
</style>
</head>
<body>
{{navBar|safe}}
<div style="margin-top:50px;">
<select type="select" id="networkArea"><option>Hill</option><option selected>Bread</option><option>Milk</option><option>GTC</option></select>
<select type="select" id="networkTerm"></select>
<button class="btn btn-primary" id="refreshGraph"><span class="glyphicon glyphicon-refresh"/></button>
</div>
<svg style="position:relative;float:left;" width="900" height="500"></svg>
<div style="position:relative;float:left;"><h3>Detail:</h3><p id="legendDetail"></p>
<button class="btn btn-primary" id="getSurveys" data-toggle="modal" data-target="#myModal"><span class="glyphicon glyphicon-list"></span>Surveys</button></div>

<!-- Modal -->
<div id="myModal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal">&times;</button>
        <h4 class="modal-title">Sample of Surveys</h4>
      </div>
      <div class="modal-body">
        <table class="table table-striped">
			<thead>
				<tr><th>Sentiment</th><th>Survey Summary</th><th><button class="btn btn-primary" id="downloadSummaryTerms"><span class="glyphicon glyphicon-save"/></button></th></tr>
			</thead>
			<tbody id="surveyDataTable">
			</tbody>
		</table>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
      </div>
    </div>
  </div>
</div>

<script src="https://d3js.org/d3.v4.min.js"></script>
<script>
var gd={}
var from=""
var to=""

function setLegend(c){
	var t = c.match(/>(.*?)<\//g)[0].replace("<","").replace(">","").replace("/","");
	for(i in gd['links']){
		var obj=gd['links'][i]
		if(obj['target']==t){
			to=t
			from=obj['source']
			//t='<strong>'+t+'</strong>'+'<br>associated to<br><strong>'+obj['source']+'</strong><br>Positive: '+obj['positive']+'<br>Negative: '+obj['negative']+'<br>Neutral: '+obj['neutral']
			t='<strong>'+t+'</strong>'+'<br>associated to<br><strong>'+obj['source']+'</strong>'
		}
	}
	$("#legendDetail").html(t);
}
$("#refreshGraph").click(function(){drawGraph($("#networkArea").val().toLowerCase(),$("#networkTerm").val())})
function xhRef(urlPath){var res=[];$.ajax({async:false,url:urlPath}).done(function(a) {res = a;}).fail(function() {return [];}).always(function() {});return res;}

function getNetworkTerms(){
	$('#networkTerm').html("");
	var data=xhRef("/graph/networkTerms?cat="+$("#networkArea").val().toLowerCase())
	var s= document.getElementById('networkTerm');
	var count=0;
	for(i in data){
		s.options[s.options.length]= new Option(data[i],data[i]);
	}
}
getNetworkTerms();

function drawGraph(cat,term){
d3.selectAll("svg > *").remove();
var svg = d3.select("svg"),
    width = +svg.attr("width"),
    height = +svg.attr("height");

var color = d3.scaleOrdinal(d3.schemeCategory20);

var simulation = d3.forceSimulation()
    .force("link", d3.forceLink().id(function(d) { return d.id; }))
.force("charge", d3.forceManyBody().strength(-600).distanceMax(200).distanceMin(10))
    .force("center", d3.forceCenter(width / 2, height / 2));

d3.json("/graph/network?cat="+cat+"&term="+term, function(error, graph) {
  if (error) throw error;

  var link = svg.append("g")
      .attr("class", "links")
    .selectAll("line")
    .data(graph.links)
    .enter().append("line")
      .attr("stroke-width", function(d) { return d.value/170; });

  var nodes = svg.append("g")
      .attr("class", "nodes")
    .selectAll("circle")
    .data(graph.nodes)
    .enter().append("g")
  
  nodes.append("circle")
      .attr("r", 5)
      .attr("fill", function(d) { return color(d.group); })
       .call(d3.drag()
         .on("start", dragstarted)
         .on("drag", dragged)
         .on("end", dragended));
  
  nodes.append("text")
    .attr("dx", 8)
    .attr("dy", ".35em")
    .text(function(d) { return d.id }).on("mouseenter",function(){var c=this;setLegend(c.outerHTML);});
  
  simulation
      .nodes(graph.nodes)
      .on("tick", ticked);

  simulation.force("link")
      .links(graph.links);

  function ticked() {
    link
        .attr("x1", function(d) { return d.source.x; })
        .attr("y1", function(d) { return d.source.y; })
        .attr("x2", function(d) { return d.target.x; })
        .attr("y2", function(d) { return d.target.y; });

    nodes
        .attr("transform", function(d) { return "translate("+[d.x,d.y]+")" });
  }
});

function dragstarted(d) {
  if (!d3.event.active) simulation.alphaTarget(0.3).restart();
  d.fx = d.x;
  d.fy = d.y;
}

function dragged(d) {
  d.fx = d3.event.x;
  d.fy = d3.event.y;
}

function dragended(d) {
  if (!d3.event.active) simulation.alphaTarget(0);
  d.fx = null;
  d.fy = null;
}
}
drawGraph($("#networkArea").val().toLowerCase(),"")
gd=xhRef("/graph/network?cat="+$("#networkArea").val().toLowerCase()+"&term=")

$("#networkArea").change(function(){
getNetworkTerms()
gd=xhRef("/graph/network?cat="+$("#networkArea").val().toLowerCase()+"&term=")
drawGraph($("#networkArea").val().toLowerCase(),"")
})

$("#getSurveys").click(function(){
	var sd=xhRef("/getSummary?from="+from+"&to="+to+"&term="+$("#networkArea").val());
	var str='';
	for(i in sd){
		str=str+'<tr><td>'+sd[i]['sentiment_label']+'</td><td>'+sd[i]['summary']+'</td></tr>';
	}
	$("#surveyDataTable").html(str);
});
$("#downloadSummaryTerms").click(function(){window.location='/download/getSummary?from="+from+"&to="+to+"&term="+$("#networkArea").val()';})
</script>